\name{cdk.lf, moe.lf, bci.lf}
\alias{cdk.lf}
\alias{moe.lf}
\alias{bci.lf}
\title{
    Functions to parse lines from fingerprint files
}
\description{
These functions take a single line and parses it to produce 
a vector of integers which represents the position of the 'on' bits in
a fingerprint. This allows the user to use \code{read.fp} with arbitrary fingerprint
files. A new file format can be handled by defining a new line parser function.
Currently the three functions process fingerprint files obtained from the 
CDK (\url{http://cdk.sourceforge.net}), MOE (\url{http://chemcomp.com})
and BCI (\url{http://www.digitalchemistry.co.uk/})

}
\usage{
    cdk.lf(line)
    moe.lf(line)
    bci.lf(line)
}
\arguments{
    \item{line}{
        The line to parse
    }
}
\value{
A vector of integers representing 'on' bits 
}
\author{Rajarshi Guha \email{rguha@indiana.edu}}
\keyword{logic}



